/*This file must be used with FLTK1.3 with gl enabled
 * config.h is generated by fltk on your system
 * compile with: fltk-config --use-gl --compile test6.cpp
 * the difference of test6.cpp from test8.cpp is test6.cpp does not use alpha blending
*/
#include "config.h"
#include <math.h>
#include <stdio.h>
#include <FL/Fl.H>
#include <FL/gl.h>
#include <FL/Fl_Window.H>
#include <FL/Fl_Gl_Window.H>
#include "../include/vase_rend_draft_2.h"

#define MATH_PI 3.141592654

class Gl_Window : public Fl_Gl_Window
{
	void draw();
	int handle(int);

	public:
	Gl_Window(int x,int y,int w,int h,const char *l=0)
		: Fl_Gl_Window(x,y,w,h,l) {}
	Gl_Window(int w,int h,const char *l=0)
		: Fl_Gl_Window(w,h,l) {}
};
int Gl_Window::handle(int e)
{
	return Fl_Gl_Window::handle(e);
}

void Gl_Window::draw()
{
	if (!valid())
	{
		glMatrixMode(GL_PROJECTION);
			glLoadIdentity();
			glOrtho( 0,w(),h(),0,0.0f,100.0f);
			glClearColor( 1.0,1.0,1.0,0.5f);
			glClearDepth( 0.0f);
	}
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_COLOR_ARRAY);
	
	for ( int i=0; i<20; i++)
	{
		line ( 5+29.7*i,187, 35+29.7*i,8, //coordinates
			0.3*(i+1),	//thickness in px
			0.0, 0.0, 0.0,	//line color
			1.0, 1.0, 1.0,	//background color
			false);		//not use blending
	}
	
	for ( double ag=0; ag<=2*MATH_PI; ag+=MATH_PI/20.0)
	{
		double tx2=90*cos(ag);
		double ty2=90*sin(ag);
		double tx1=20*cos(ag);
		double ty1=20*sin(ag);
		//hair_line ( 706+tx1,97-ty1, 706+tx2,97-ty2, false);
		line ( 706+tx1,97-ty1, 706+tx2,97-ty2, //coordinates
			1.0,		//thickness in px
			0.0, 0.0, 0.0,	//line color
			1.0, 1.0, 1.0,	//background color
			false);		//not use blending
	}
	
	glDisableClientState(GL_VERTEX_ARRAY);
	glDisableClientState(GL_COLOR_ARRAY);
}

int main(int argc, char **argv)
{
	Gl_Window gl_wnd( 606+200,194,"test6 [fltk-opengl][vertex array]");
	gl_wnd.position( 170,360);
	gl_wnd.show();
	return Fl::run();
}
